Status: Resolved Priority: Must have
Author: Dave no-lastname-given Category: Extension Manager
Created: 2013-07-28 Assigned To:
Updated: 2015-03-24 Due date:
PHP Version:
Complexity: medium
Sprint Focus:
Subject: The ability to just import/fetch/download an extension from the TER without installing it.
Description

It would be nice if we could just import/fetch/download an extension from the TER but not automatically install it into a running system.
This was possible to do in the old extension manager but not in the extensionmanager version 6.x.x.

I normally check out the contents of an extension myself before installing an extension.
Sometimes new extensions can break a running Typo3 site. Some extension authors have my trust and I may automatically install
them, but when I am working with something/someone new I always double check the extension manually by putting my eye quick to
the code.

I do this because in Typo3, security auditing of extensions is an after thought, meaning it occurs after an extension has already been
publically available in the TER, for that reason alone, automatic installing of extensions does more harm than good.

Automatic installs of extensions DOES NOT allow you to do your own security audit first.
That is a very compelling reason to re-introduce this feature. 
It is something you should encourage new Typo3 integrators to be doing.
Security should always trump convenience, if not, you are doing it wrong.

On a side note: sometimes I will download an extension for modification reasons. 
I do not want to install it until after I have made my changes.

Related issues:
related to Core - Bug # 50347: ExtensionManager: Overwriting existing extensi... Closed 2013-07-23
duplicated by Core - Bug # 55373: Extension manager installs (activates) exte... Closed 2014-01-27

Associated revisions
Revision d34359b9 - 2015-03-24 10:55 - Susanne Moog

[FEATURE] Add option to disable automatic installation of extensions

The extension manager currently downloads and installs an extension
from TER or after file upload directly. Some people want to do some
audits or modifications before installing an extension, therefore there
should be an option to disable the automatic installation process and
just download an extension like it was default in older extension managers.

Like suggested in the related UX/forge issue this patch implements
a simple switch in the configuration of the extension manager itself.

Resolves: #50501
Related: #50582
Releases: master
Change-Id: I538306fd9a067abebe0ffd36704f95eb52c3c454
Reviewed-on: http://review.typo3.org/30972
Reviewed-by: Nicole Cordes <typo3@cordes.co>
Tested-by: Nicole Cordes <typo3@cordes.co>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>

History
#1 - 2013-07-29 17:26 - Philipp Gampe
- Status changed from New to Accepted

I second to this.

An easy solution would be to set a switch in the extensionmanager extension to either install it directly or not. This should be simple to implement.

Otherwise we need an UI/UX concept again to let the user choose while downloading or before installing it.

Can you please create an issue in the UX team tracker and relate it to this one?

#2 - 2013-07-29 19:29 - Ingo Renner
- Status changed from Accepted to Rejected

Dave no-lastname-given wrote:

...download an extension from the TER but not automatically install it into a running system.

(emphasize added by me)

You don't do that on a production system.

#3 - 2013-07-30 12:43 - Dave no-lastname-given

Ingo Renner wrote:

You don't do that on a production system.

No you probably shouldn't on a production system, I am not saying that I do, but it does not mean you even have to do it on a NON production system.
The point is there is no choice to just import and not install. 
And that is a security issue in my mind regardless if it is on a production system or not.

Because your non-production system is also connected to the net or how else did you get the extension in the extension manager??? That does not
make it safe from a potentially malicious extension that automatically installs.

And your reply doesnt address the other issue I pointed out, sometimes you want to just import but not install an extension for modification reasons.

IMHO your rejection of this idea is not fully baked.
#4 - 2013-07-30 12:56 - Dave no-lastname-given

Also a running system is not just a production system, it is a Typo3 install in production or in a state of development/staging.

#5 - 2013-07-30 13:21 - Philipp Gampe
- Status changed from Rejected to Needs Feedback
- Complexity set to medium

@Ingo I second the idea to just fetch an extension.

#6 - 2013-07-31 10:57 - Dave no-lastname-given

Made a related UX issue for extra feedback: Feature #50582

#7 - 2013-07-31 12:58 - Philipp Gampe

We need another action in between that shows all changes to be done (just as in the old (old) EM)

#8 - 2013-07-31 14:01 - Dave no-lastname-given

Philipp Gampe wrote:

We need another action in between that shows all changes to be done (just as in the old (old) EM)

I think I mentioned this in the UX issue, I agree. I thought though you could keep the current behaviour in the new EM (simple mode: auto install at
own risk no questions asked.) and then a more verbose version (advanced mode:where all install/import questions are asked and options considered)
and the process is thoroughly reviewed before executing.

I did find the old process in the old EM a bit clunky (@see off-topic) even though you could cope with it, it was not very clear when dealing with
dependencies in what step of your initial extension install you were in when dependencies installations were being satisfied. I could imagine some nice
ajax wizardy here.

Though I think the UX team might come up with a more elegant solution.

off-topic:
Another gripe of mine is that extensions installs are not very easily rolled back to previous versions. They are always overwritten, I think that is a
shame. It would be cool if you could import multiple versions of the same extension, and then just symbolically link to the actively installed one. Maybe
also support for an ext_rollback.php to rollback any DB/structure changes. But that would require some serious rethink of how extensions are treated.

Versioned extensions directory structure for rollback:

my_extension -> .my_extension/1.0.2
.my_extension/
  1.0.1/
  1.0.2/
  1.0.3/

It would also support old extensions that cannot be rolled back.

Anyway sorry for the Off-topic. Maybe I should post that as a far future feature or maybe it should hang in the shadows for now, I am not sure. It would
be cool though.

#9 - 2014-01-06 11:35 - Alexander Opitz
- Status changed from Needs Feedback to New

#10 - 2014-06-20 21:54 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30972

#11 - 2014-06-22 12:35 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30972

#12 - 2014-07-24 12:08 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/30972

#13 - 2014-09-14 12:03 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/30972

#14 - 2014-12-10 12:04 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/30972

#15 - 2015-03-23 12:00 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/30972

#16 - 2015-03-23 12:12 - Gerrit Code Review
Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/30972

#17 - 2015-03-24 11:00 - Susanne Moog
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:d34359b948246393a42f4d0b0a58f5e001ef7c50.
